//+------------------------------------------------------------------+
//|                                                    HullTrend.mq5 |
//|                                     Copyright  2005, adoleh2000 |
//|                                             adoleh2000@yahoo.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, adoleh2000."
#property  link      "adoleh2000@yahoo.com"
//--- Versionsnummer Anzeige
#property version   "1.00"
//--- das Rendern der Anzeige im Hauptfenster
#property indicator_chart_window
//--- Anzahl der Leuchtmelder 2 Puffer
#property indicator_buffers 2
//--- verwendet eine grafische Aufbau
#property indicator_plots   1
//+----------------------------------------------+
//| Renderingoptionen des Indikators |
//+----------------------------------------------+
//--- Darstellung des Indikators in Form von farbigen Wolken
#property indicator_type1   DRAW_FILLING
//--- als Farben des Indikators verwendet
#property indicator_color1  clrMediumSpringGreen,clrViolet
//--- zeigt die Bezeichnung des Indikators
#property indicator_label1  "HullTrend"
//+----------------------------------------------+
//| Beschreibung der Klasse CXMA |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+----------------------------------------------+
//--- Anzeige Klassenvariablen CXMA aus der Datei SmoothAlgorithms.mqh
CXMA XMA1,XMA2,XMA3;
//+----------------------------------------------+
//| Deklaration einer Enumeration |
//+----------------------------------------------+
/*enum Smooth_Method - ???????????? ????????? ? ????? SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//| Deklaration einer Enumeration |
//+----------------------------------------------+
enum Applied_price_ //Der Typ der Konstanten
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4)
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price
   PRICE_DEMARK_         //Demark Price
  };
//+----------------------------------------------+
//| Deklaration von Konstanten |
//+----------------------------------------------+
#define RESET 0 // Konstante fr die Rckgabe der Terminal-Befehl auf Neuberechnung des Indikators
//+----------------------------------------------+
//| Eingabeparameter des Indikators |
//+----------------------------------------------+
input uint XLength=20;                           // Zeitraum der Anzeige
input Applied_price_ IPC=PRICE_CLOSE;            // Preis des Indikators
input Smooth_Method XMA_Method=MODE_LWMA;        // Die Methode der Mittelung
input int XPhase=15;                             // Der Parameter Glttung
//--- fr JJMA einging innerhalb -100.. 100, Einfluss auf die Qualitt des bergangsprozesses
//+----------------------------------------------+
//--- die Deklaration von dynamischen Arrays, die in
// spter verwendet als kontrollleuchten Puffern
double ExtABuffer[],ExtBBuffer[];
//--- Anzeige ganzzahlige Variablen vom Ursprung der Daten
int  min_rates_1,min_rates_2,min_rates_total;

int XLength2,SqrXLength;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- Initialisierung der Variablen
   XLength2=int(XLength/2);
   SqrXLength=int(MathFloor(MathSqrt(XLength)));
//--- Initialisierung der Variablen Ursprung der Daten
   min_rates_1=XMA1.GetStartBars(XMA_Method,XLength,XPhase);
   min_rates_total=min_rates_1+XMA1.GetStartBars(XMA_Method,SqrXLength,XPhase);
//--- die Umwandlung eines dynamischen Arrays in der Anzeige-Puffer
   SetIndexBuffer(0,ExtABuffer,INDICATOR_DATA);
//--- die Umwandlung eines dynamischen Arrays in der Anzeige-Puffer
   SetIndexBuffer(1,ExtBBuffer,INDICATOR_DATA);
//--- Umsetzung der Verschiebung des Ursprungs-rendering-Anzeige
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//--- Installation eines Indikators, die nicht sichtbar im Chart
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//--- erstellen Sie den Namen fr die Anzeige in einem separaten ??????? und in der QuickInfo angezeigt
   IndicatorSetString(INDICATOR_SHORTNAME,"HullTrend");
//--- Definition der Genauigkeit eines Indikators
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//--- Abschluss der Initialisierung
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    // die Anzahl der Geschichten in den Bars auf dem aktuellen Tiko
                const int prev_calculated,// die Anzahl der Geschichten in den Bars in der vorherigen Tiko
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//--- berprfen Sie die Anzahl der Bars auf die Angemessenheit der fr die Berechnung der
   if(rates_total<min_rates_total) return(RESET);
//--- Deklarationen lokaler Variablen
   int first,bar;
//--- Deklaration der Variablen float
   double price,xma,xma2,hma,xhma;
//--- Berechnung der startnummer first fr den Zyklus Neuberechnung Bars
   if(prev_calculated>rates_total || prev_calculated<=0) // Umsatzsteuer auf den ersten Start der Berechnung des Indikators
     {
      first=0; // startnummer fr die Berechnung aller Bars
     }
   else first=prev_calculated-1; // startnummer fr die Berechnung der neuen Bars
//--- Hauptschleife die Berechnung des Indikators
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      price=PriceSeries(IPC,bar,open,low,high,close);
      xma2=XMA1.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength2,price,bar,false);
      xma=XMA2.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength,price,bar,false);
      hma=2*xma2-xma;
      xhma=XMA3.XMASeries(min_rates_1,prev_calculated,rates_total,XMA_Method,XPhase,SqrXLength,hma,bar,false);
      ExtABuffer[bar]=hma;
      ExtBBuffer[bar]=xhma;
     }

   return(rates_total);
  }
//+------------------------------------------------------------------+
